#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# Interpreter version: python 2.7
#
# !!! DO NOT EDIT THIS FILE - THIS IS GENERATED FILE !!!
# Imports =====================================================================
from collections import namedtuple


# Functions and classes =======================================================

# !!! DO NOT EDIT THIS FILE - THIS IS GENERATED FILE !!!
# !!! DO NOT EDIT THIS FILE - THIS IS GENERATED FILE !!!

_PUB_FIELDS = [
    "isbn",
    "uuid",
    "aleph_id",
    "b64_data",
    "dir_pointer",
]


class Archive(namedtuple('Archive', _PUB_FIELDS)):
    '''
    Communication structure used to sent data to `storage` subsystem over AMQP.

    Attributes:
        isbn (str): ISBN for the archive.
        uuid (str): UUID string to pair the archive with edeposit.
        aleph_id (str): ID used in aleph.
        b64_data (str): Base64 encoded data ebook file.
        dir_pointer (str): Pointer to the directory on the file server.
    '''
    def __new__(self, *args, **kwargs):
        for field, arg in zip(_PUB_FIELDS, args):
            kwargs[field] = arg

        for key in _PUB_FIELDS:
            if key not in kwargs:
                kwargs[key] = None

        return super(Archive, self).__new__(self, **kwargs)

    def __init__(self, *args, **kwargs):
        for field, arg in zip(_PUB_FIELDS, args):
            kwargs[field] = arg

        for key, val in kwargs.iteritems():
            if key not in _PUB_FIELDS:
                raise ValueError("Unknown parameter '%s'!" % key)

            self.__dict__[key] = val

# !!! DO NOT EDIT THIS FILE - THIS IS GENERATED FILE !!!
# !!! DO NOT EDIT THIS FILE - THIS IS GENERATED FILE !!!
